// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientControlMode.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientControlMode __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientControlMode __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientControlMode_
{
  using Type = ClientControlMode_<ContainerAllocator>;

  explicit ClientControlMode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visual_recording_state = 0;
      this->map_state = 0;
      this->localization_state = 0;
      this->recording_state = 0;
      this->alignment_state = 0;
      this->mask_state = 0;
    }
  }

  explicit ClientControlMode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visual_recording_state = 0;
      this->map_state = 0;
      this->localization_state = 0;
      this->recording_state = 0;
      this->alignment_state = 0;
      this->mask_state = 0;
    }
  }

  // field types and members
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _visual_recording_state_type =
    uint8_t;
  _visual_recording_state_type visual_recording_state;
  using _map_state_type =
    uint8_t;
  _map_state_type map_state;
  using _localization_state_type =
    uint8_t;
  _localization_state_type localization_state;
  using _recording_state_type =
    uint8_t;
  _recording_state_type recording_state;
  using _alignment_state_type =
    uint8_t;
  _alignment_state_type alignment_state;
  using _mask_state_type =
    uint8_t;
  _mask_state_type mask_state;

  // setters for named parameter idiom
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__visual_recording_state(
    const uint8_t & _arg)
  {
    this->visual_recording_state = _arg;
    return *this;
  }
  Type & set__map_state(
    const uint8_t & _arg)
  {
    this->map_state = _arg;
    return *this;
  }
  Type & set__localization_state(
    const uint8_t & _arg)
  {
    this->localization_state = _arg;
    return *this;
  }
  Type & set__recording_state(
    const uint8_t & _arg)
  {
    this->recording_state = _arg;
    return *this;
  }
  Type & set__alignment_state(
    const uint8_t & _arg)
  {
    this->alignment_state = _arg;
    return *this;
  }
  Type & set__mask_state(
    const uint8_t & _arg)
  {
    this->mask_state = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CLIENT_CONTROL_STATE_INIT =
    0u;
  static constexpr uint8_t CLIENT_CONTROL_STATE_READY =
    1u;
  static constexpr uint8_t CLIENT_CONTROL_STATE_RUN =
    2u;
  static constexpr uint8_t CLIENT_CONTROL_STATE_NOT_AVAILABLE =
    4u;

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientControlMode
    std::shared_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientControlMode
    std::shared_ptr<bosch_locator_bridge::msg::ClientControlMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientControlMode_ & other) const
  {
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->visual_recording_state != other.visual_recording_state) {
      return false;
    }
    if (this->map_state != other.map_state) {
      return false;
    }
    if (this->localization_state != other.localization_state) {
      return false;
    }
    if (this->recording_state != other.recording_state) {
      return false;
    }
    if (this->alignment_state != other.alignment_state) {
      return false;
    }
    if (this->mask_state != other.mask_state) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientControlMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientControlMode_

// alias to use template instance with default allocator
using ClientControlMode =
  bosch_locator_bridge::msg::ClientControlMode_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t ClientControlMode_<ContainerAllocator>::CLIENT_CONTROL_STATE_INIT;
template<typename ContainerAllocator>
constexpr uint8_t ClientControlMode_<ContainerAllocator>::CLIENT_CONTROL_STATE_READY;
template<typename ContainerAllocator>
constexpr uint8_t ClientControlMode_<ContainerAllocator>::CLIENT_CONTROL_STATE_RUN;
template<typename ContainerAllocator>
constexpr uint8_t ClientControlMode_<ContainerAllocator>::CLIENT_CONTROL_STATE_NOT_AVAILABLE;

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__STRUCT_HPP_
