// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientLocalizationPose.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_localization_pose__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `age`
#include "builtin_interfaces/msg/detail/duration__functions.h"
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
bosch_locator_bridge__msg__ClientLocalizationPose__init(bosch_locator_bridge__msg__ClientLocalizationPose * msg)
{
  if (!msg) {
    return false;
  }
  // age
  if (!builtin_interfaces__msg__Duration__init(&msg->age)) {
    bosch_locator_bridge__msg__ClientLocalizationPose__fini(msg);
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    bosch_locator_bridge__msg__ClientLocalizationPose__fini(msg);
    return false;
  }
  // unique_id
  // state
  // epoch
  return true;
}

void
bosch_locator_bridge__msg__ClientLocalizationPose__fini(bosch_locator_bridge__msg__ClientLocalizationPose * msg)
{
  if (!msg) {
    return;
  }
  // age
  builtin_interfaces__msg__Duration__fini(&msg->age);
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // unique_id
  // state
  // epoch
}

bool
bosch_locator_bridge__msg__ClientLocalizationPose__are_equal(const bosch_locator_bridge__msg__ClientLocalizationPose * lhs, const bosch_locator_bridge__msg__ClientLocalizationPose * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // age
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->age), &(rhs->age)))
  {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // unique_id
  if (lhs->unique_id != rhs->unique_id) {
    return false;
  }
  // state
  if (lhs->state != rhs->state) {
    return false;
  }
  // epoch
  if (lhs->epoch != rhs->epoch) {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientLocalizationPose__copy(
  const bosch_locator_bridge__msg__ClientLocalizationPose * input,
  bosch_locator_bridge__msg__ClientLocalizationPose * output)
{
  if (!input || !output) {
    return false;
  }
  // age
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->age), &(output->age)))
  {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // unique_id
  output->unique_id = input->unique_id;
  // state
  output->state = input->state;
  // epoch
  output->epoch = input->epoch;
  return true;
}

bosch_locator_bridge__msg__ClientLocalizationPose *
bosch_locator_bridge__msg__ClientLocalizationPose__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientLocalizationPose * msg = (bosch_locator_bridge__msg__ClientLocalizationPose *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientLocalizationPose), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientLocalizationPose));
  bool success = bosch_locator_bridge__msg__ClientLocalizationPose__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientLocalizationPose__destroy(bosch_locator_bridge__msg__ClientLocalizationPose * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientLocalizationPose__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__init(bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientLocalizationPose * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientLocalizationPose *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientLocalizationPose), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientLocalizationPose__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientLocalizationPose__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__fini(bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientLocalizationPose__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientLocalizationPose__Sequence *
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * array = (bosch_locator_bridge__msg__ClientLocalizationPose__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientLocalizationPose__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__destroy(bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__are_equal(const bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * lhs, const bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientLocalizationPose__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientLocalizationPose__Sequence__copy(
  const bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * input,
  bosch_locator_bridge__msg__ClientLocalizationPose__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientLocalizationPose);
    bosch_locator_bridge__msg__ClientLocalizationPose * data =
      (bosch_locator_bridge__msg__ClientLocalizationPose *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientLocalizationPose__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientLocalizationPose__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientLocalizationPose__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
