// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from bosch_locator_bridge:msg/ClientRecordingVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__STRUCT_H_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_STARTUP'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_RECORDING_STATUS_STARTUP = -2l
};

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_DELAYED'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_RECORDING_STATUS_DELAYED = 1l
};

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_OK'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_RECORDING_STATUS_OK = 2l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL = 0l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE = 1l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE'.
enum
{
  bosch_locator_bridge__msg__ClientRecordingVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE = 2l
};

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'path_types'
#include "rosidl_runtime_c/primitives_sequence.h"

// Struct defined in msg/ClientRecordingVisualization in the package bosch_locator_bridge.
typedef struct bosch_locator_bridge__msg__ClientRecordingVisualization
{
  builtin_interfaces__msg__Time timestamp;
  uint64_t visualization_id;
  int32_t status;
  double distance_to_last_lc;
  double delay;
  double progress;
  rosidl_runtime_c__int32__Sequence path_types;
} bosch_locator_bridge__msg__ClientRecordingVisualization;

// Struct for a sequence of bosch_locator_bridge__msg__ClientRecordingVisualization.
typedef struct bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence
{
  bosch_locator_bridge__msg__ClientRecordingVisualization * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__STRUCT_H_
