// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:srv/ClientMapStart.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/srv/detail/client_map_start__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `recording_name`
// Member `client_map_name`
#include "rosidl_runtime_c/string_functions.h"

bool
bosch_locator_bridge__srv__ClientMapStart_Request__init(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  if (!msg) {
    return false;
  }
  // recording_name
  if (!rosidl_runtime_c__String__init(&msg->recording_name)) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
    return false;
  }
  // client_map_name
  if (!rosidl_runtime_c__String__init(&msg->client_map_name)) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__fini(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  if (!msg) {
    return;
  }
  // recording_name
  rosidl_runtime_c__String__fini(&msg->recording_name);
  // client_map_name
  rosidl_runtime_c__String__fini(&msg->client_map_name);
}

bool
bosch_locator_bridge__srv__ClientMapStart_Request__are_equal(const bosch_locator_bridge__srv__ClientMapStart_Request * lhs, const bosch_locator_bridge__srv__ClientMapStart_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // recording_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->recording_name), &(rhs->recording_name)))
  {
    return false;
  }
  // client_map_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->client_map_name), &(rhs->client_map_name)))
  {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__srv__ClientMapStart_Request__copy(
  const bosch_locator_bridge__srv__ClientMapStart_Request * input,
  bosch_locator_bridge__srv__ClientMapStart_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // recording_name
  if (!rosidl_runtime_c__String__copy(
      &(input->recording_name), &(output->recording_name)))
  {
    return false;
  }
  // client_map_name
  if (!rosidl_runtime_c__String__copy(
      &(input->client_map_name), &(output->client_map_name)))
  {
    return false;
  }
  return true;
}

bosch_locator_bridge__srv__ClientMapStart_Request *
bosch_locator_bridge__srv__ClientMapStart_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Request * msg = (bosch_locator_bridge__srv__ClientMapStart_Request *)allocator.allocate(sizeof(bosch_locator_bridge__srv__ClientMapStart_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__srv__ClientMapStart_Request));
  bool success = bosch_locator_bridge__srv__ClientMapStart_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__destroy(bosch_locator_bridge__srv__ClientMapStart_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__srv__ClientMapStart_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__init(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Request * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__srv__ClientMapStart_Request *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__srv__ClientMapStart_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__srv__ClientMapStart_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__srv__ClientMapStart_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__fini(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__srv__ClientMapStart_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__srv__ClientMapStart_Request__Sequence *
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array = (bosch_locator_bridge__srv__ClientMapStart_Request__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__destroy(bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__are_equal(const bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * lhs, const bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__srv__ClientMapStart_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__srv__ClientMapStart_Request__Sequence__copy(
  const bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * input,
  bosch_locator_bridge__srv__ClientMapStart_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__srv__ClientMapStart_Request);
    bosch_locator_bridge__srv__ClientMapStart_Request * data =
      (bosch_locator_bridge__srv__ClientMapStart_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__srv__ClientMapStart_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__srv__ClientMapStart_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__srv__ClientMapStart_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
bosch_locator_bridge__srv__ClientMapStart_Response__init(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__fini(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
bosch_locator_bridge__srv__ClientMapStart_Response__are_equal(const bosch_locator_bridge__srv__ClientMapStart_Response * lhs, const bosch_locator_bridge__srv__ClientMapStart_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__srv__ClientMapStart_Response__copy(
  const bosch_locator_bridge__srv__ClientMapStart_Response * input,
  bosch_locator_bridge__srv__ClientMapStart_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

bosch_locator_bridge__srv__ClientMapStart_Response *
bosch_locator_bridge__srv__ClientMapStart_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Response * msg = (bosch_locator_bridge__srv__ClientMapStart_Response *)allocator.allocate(sizeof(bosch_locator_bridge__srv__ClientMapStart_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__srv__ClientMapStart_Response));
  bool success = bosch_locator_bridge__srv__ClientMapStart_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__destroy(bosch_locator_bridge__srv__ClientMapStart_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__srv__ClientMapStart_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__init(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Response * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__srv__ClientMapStart_Response *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__srv__ClientMapStart_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__srv__ClientMapStart_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__srv__ClientMapStart_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__fini(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__srv__ClientMapStart_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__srv__ClientMapStart_Response__Sequence *
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array = (bosch_locator_bridge__srv__ClientMapStart_Response__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__destroy(bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__are_equal(const bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * lhs, const bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__srv__ClientMapStart_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__srv__ClientMapStart_Response__Sequence__copy(
  const bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * input,
  bosch_locator_bridge__srv__ClientMapStart_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__srv__ClientMapStart_Response);
    bosch_locator_bridge__srv__ClientMapStart_Response * data =
      (bosch_locator_bridge__srv__ClientMapStart_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__srv__ClientMapStart_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__srv__ClientMapStart_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__srv__ClientMapStart_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
