// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignLandmarkObservationNotice.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientGlobalAlignLandmarkObservationNotice_
{
  using Type = ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>;

  explicit ClientGlobalAlignLandmarkObservationNotice_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_index = 0ul;
      this->landmark_index = 0ul;
    }
  }

  explicit ClientGlobalAlignLandmarkObservationNotice_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_index = 0ul;
      this->landmark_index = 0ul;
    }
  }

  // field types and members
  using _pose_index_type =
    uint32_t;
  _pose_index_type pose_index;
  using _landmark_index_type =
    uint32_t;
  _landmark_index_type landmark_index;

  // setters for named parameter idiom
  Type & set__pose_index(
    const uint32_t & _arg)
  {
    this->pose_index = _arg;
    return *this;
  }
  Type & set__landmark_index(
    const uint32_t & _arg)
  {
    this->landmark_index = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientGlobalAlignLandmarkObservationNotice_ & other) const
  {
    if (this->pose_index != other.pose_index) {
      return false;
    }
    if (this->landmark_index != other.landmark_index) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientGlobalAlignLandmarkObservationNotice_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientGlobalAlignLandmarkObservationNotice_

// alias to use template instance with default allocator
using ClientGlobalAlignLandmarkObservationNotice =
  bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__STRUCT_HPP_
