// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignVisualization.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_global_align_visualization__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `landmarks`
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_visualization_information__functions.h"
// Member `observations`
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_observation_notice__functions.h"

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  // visualization_id
  // landmarks
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__init(&msg->landmarks, 0)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  // observations
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__init(&msg->observations, 0)) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // visualization_id
  // landmarks
  bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__fini(&msg->landmarks);
  // observations
  bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__fini(&msg->observations);
}

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__are_equal(const bosch_locator_bridge__msg__ClientGlobalAlignVisualization * lhs, const bosch_locator_bridge__msg__ClientGlobalAlignVisualization * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // visualization_id
  if (lhs->visualization_id != rhs->visualization_id) {
    return false;
  }
  // landmarks
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__are_equal(
      &(lhs->landmarks), &(rhs->landmarks)))
  {
    return false;
  }
  // observations
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__are_equal(
      &(lhs->observations), &(rhs->observations)))
  {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__copy(
  const bosch_locator_bridge__msg__ClientGlobalAlignVisualization * input,
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // visualization_id
  output->visualization_id = input->visualization_id;
  // landmarks
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkVisualizationInformation__Sequence__copy(
      &(input->landmarks), &(output->landmarks)))
  {
    return false;
  }
  // observations
  if (!bosch_locator_bridge__msg__ClientGlobalAlignLandmarkObservationNotice__Sequence__copy(
      &(input->observations), &(output->observations)))
  {
    return false;
  }
  return true;
}

bosch_locator_bridge__msg__ClientGlobalAlignVisualization *
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization));
  bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__destroy(bosch_locator_bridge__msg__ClientGlobalAlignVisualization * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__init(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__fini(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence *
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array = (bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__destroy(bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__are_equal(const bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * lhs, const bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientGlobalAlignVisualization__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence__copy(
  const bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * input,
  bosch_locator_bridge__msg__ClientGlobalAlignVisualization__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientGlobalAlignVisualization);
    bosch_locator_bridge__msg__ClientGlobalAlignVisualization * data =
      (bosch_locator_bridge__msg__ClientGlobalAlignVisualization *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientGlobalAlignVisualization__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientGlobalAlignVisualization__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientGlobalAlignVisualization__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
