// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'landmarks'
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_visualization_information__struct.hpp"
// Member 'observations'
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_observation_notice__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignVisualization __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignVisualization __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientGlobalAlignVisualization_
{
  using Type = ClientGlobalAlignVisualization_<ContainerAllocator>;

  explicit ClientGlobalAlignVisualization_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
    }
  }

  explicit ClientGlobalAlignVisualization_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _visualization_id_type =
    uint64_t;
  _visualization_id_type visualization_id;
  using _landmarks_type =
    std::vector<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkVisualizationInformation_<ContainerAllocator>, typename ContainerAllocator::template rebind<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkVisualizationInformation_<ContainerAllocator>>::other>;
  _landmarks_type landmarks;
  using _observations_type =
    std::vector<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>, typename ContainerAllocator::template rebind<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>::other>;
  _observations_type observations;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__visualization_id(
    const uint64_t & _arg)
  {
    this->visualization_id = _arg;
    return *this;
  }
  Type & set__landmarks(
    const std::vector<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkVisualizationInformation_<ContainerAllocator>, typename ContainerAllocator::template rebind<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkVisualizationInformation_<ContainerAllocator>>::other> & _arg)
  {
    this->landmarks = _arg;
    return *this;
  }
  Type & set__observations(
    const std::vector<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>, typename ContainerAllocator::template rebind<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice_<ContainerAllocator>>::other> & _arg)
  {
    this->observations = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientGlobalAlignVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientGlobalAlignVisualization_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->visualization_id != other.visualization_id) {
      return false;
    }
    if (this->landmarks != other.landmarks) {
      return false;
    }
    if (this->observations != other.observations) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientGlobalAlignVisualization_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientGlobalAlignVisualization_

// alias to use template instance with default allocator
using ClientGlobalAlignVisualization =
  bosch_locator_bridge::msg::ClientGlobalAlignVisualization_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__STRUCT_HPP_
