// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientLocalizationVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_LOCALIZATION_VISUALIZATION__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_LOCALIZATION_VISUALIZATION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientLocalizationVisualization __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientLocalizationVisualization __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientLocalizationVisualization_
{
  using Type = ClientLocalizationVisualization_<ContainerAllocator>;

  explicit ClientLocalizationVisualization_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->unique_id = 0ull;
      this->loc_state = 0l;
      this->distance_to_last_lc = 0.0;
      this->delay = 0.0;
    }
  }

  explicit ClientLocalizationVisualization_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->unique_id = 0ull;
      this->loc_state = 0l;
      this->distance_to_last_lc = 0.0;
      this->delay = 0.0;
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _unique_id_type =
    uint64_t;
  _unique_id_type unique_id;
  using _loc_state_type =
    int32_t;
  _loc_state_type loc_state;
  using _distance_to_last_lc_type =
    double;
  _distance_to_last_lc_type distance_to_last_lc;
  using _delay_type =
    double;
  _delay_type delay;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__unique_id(
    const uint64_t & _arg)
  {
    this->unique_id = _arg;
    return *this;
  }
  Type & set__loc_state(
    const int32_t & _arg)
  {
    this->loc_state = _arg;
    return *this;
  }
  Type & set__distance_to_last_lc(
    const double & _arg)
  {
    this->distance_to_last_lc = _arg;
    return *this;
  }
  Type & set__delay(
    const double & _arg)
  {
    this->delay = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING =
    -3;
  static constexpr int32_t LOC_STATUS_NOT_LOCALIZED_STARTUP =
    -2;
  static constexpr int32_t LOC_STATUS_NOT_LOCALIZED =
    -1;
  static constexpr int32_t LOC_STATUS_LOCALIZED_ODO_ONLY =
    1;
  static constexpr int32_t LOC_STATUS_LOCALIZED =
    2;
  static constexpr int32_t LOC_STATUS_LOCALIZED_INTERNALUSE1 =
    3;
  static constexpr int32_t LOC_STATUS_LOCALIZED_INTERNALUSE2 =
    4;

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientLocalizationVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientLocalizationVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientLocalizationVisualization_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientLocalizationVisualization_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->unique_id != other.unique_id) {
      return false;
    }
    if (this->loc_state != other.loc_state) {
      return false;
    }
    if (this->distance_to_last_lc != other.distance_to_last_lc) {
      return false;
    }
    if (this->delay != other.delay) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientLocalizationVisualization_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientLocalizationVisualization_

// alias to use template instance with default allocator
using ClientLocalizationVisualization =
  bosch_locator_bridge::msg::ClientLocalizationVisualization_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_NOT_LOCALIZED_STARTUP;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_NOT_LOCALIZED;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_LOCALIZED_ODO_ONLY;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_LOCALIZED;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_LOCALIZED_INTERNALUSE1;
template<typename ContainerAllocator>
constexpr int32_t ClientLocalizationVisualization_<ContainerAllocator>::LOC_STATUS_LOCALIZED_INTERNALUSE2;

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_LOCALIZATION_VISUALIZATION__STRUCT_HPP_
